#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_MONGOOSE) += mongoose

#
# Paths and names
#
MONGOOSE_VERSION        := 5.3
MONGOOSE_PREFIX         := mongoose
MONGOOSE                := $(MONGOOSE_PREFIX)-$(MONGOOSE_VERSION)
MONGOOSE_SUFFIX         := zip
MONGOOSE_URL            := https://github.com/cesanta/$(MONGOOSE_PREFIX)/archive/$(MONGOOSE_VERSION).$(MONGOOSE_SUFFIX)
MONGOOSE_SOURCE         := $(SRCDIR)/$(MONGOOSE).$(MONGOOSE_SUFFIX)
MONGOOSE_DIR            := $(BUILDDIR)/$(MONGOOSE)
MONGOOSE_ARCH           := linux

MONGOOSE_SOURCE1        := $(PTXDIST_WORKSPACE)/../source/oam/$(MONGOOSE_PREFIX).init
MONGOOSE_SOURCE2        := $(PTXDIST_WORKSPACE)/../source/oam/$(MONGOOSE_PREFIX).check
MONGOOSE_SOURCE3        := $(PTXDIST_WORKSPACE)/../source/oam/index.html


# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

$(MONGOOSE_SOURCE):
	@$(call targetinfo)
	@$(call get, MONGOOSE)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------
$(STATEDIR)/mongoose.extract:
	@$(call targetinfo)
	@$(call clean, $(MONGOOSE_DIR))
	mkdir -p $(MONGOOSE_DIR)
	unzip $(MONGOOSE_SOURCE) -d $(MONGOOSE_DIR)
	@$(call patchin, MONGOOSE)
	@$(call touch)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------
MONGOOSE_PATH	:= PATH=$(CROSS_PATH)
MONGOOSE_ENV 	:= $(CROSS_ENV)
MONGOOSE_MAKEFILE := $(MONGOOSE_DIR)/$(MONGOOSE)/Makefile
#
# autoconf
#
MONGOOSE_AUTOCONF := $(CROSS_AUTOCONF_USR)

$(STATEDIR)/mongoose.prepare:
	@$(call targetinfo, $@)
	# mongoose 5.3 distribution does not come with a Makefile, so we create one here
	@echo '## do not edit! - generated by mongoose.make' > $(MONGOOSE_MAKEFILE)
	@echo 'PROG=mongoose' >> $(MONGOOSE_MAKEFILE)
	@echo '## see mongoose docs for compilation flags: http://cesanta.com/docs/Embed.shtml' >> $(MONGOOSE_MAKEFILE)
	@echo 'MONGOOSE_FLAGS = -DMONGOOSE_NO_AUTH -DMONGOOSE_NO_CGI -DMONGOOSE_NO_DAV \' >> $(MONGOOSE_MAKEFILE)
	@echo '                 -DMONGOOSE_NO_DIRECTORY_LISTING -DMONGOOSE_NO_LOGGING \' >> $(MONGOOSE_MAKEFILE)
	@echo '                 -DMONGOOSE_NO_SSI -DNS_ENABLE_IPV6' >> $(MONGOOSE_MAKEFILE)
	@echo 'CFLAGS = -W -Wall -std=c99 -pedantic -g -O0 $$(COPT)' >> $(MONGOOSE_MAKEFILE)
	@echo 'LINFLAGS = -ldl -pthread $$(CFLAGS)' >> $(MONGOOSE_MAKEFILE)
	@echo 'LIB = _$$(PROG).so' >> $(MONGOOSE_MAKEFILE)
	@echo 'linux:' >> $(MONGOOSE_MAKEFILE)
	@echo '	$$(CC) mongoose.c $$(MONGOOSE_FLAGS) -shared -fPIC -fpic -o $$(LIB) $$(LINFLAGS)' >> $(MONGOOSE_MAKEFILE)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

$(STATEDIR)/mongoose.compile:
	@$(call targetinfo, $@)
	cd $(MONGOOSE_DIR)/$(MONGOOSE) && \
	$(MONGOOSE_PATH) $(MONGOOSE_ENV) $(MAKE) $(MONGOOSE_ARCH) $(PARALLELMFLAGS)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

$(STATEDIR)/mongoose.install:
	@$(call targetinfo)
	@cp -f $(MONGOOSE_DIR)/$(MONGOOSE)/mongoose.h $(PTXCONF_SYSROOT_TARGET)/usr/include
	@cp -f $(MONGOOSE_DIR)/$(MONGOOSE)/_mongoose.so \
		$(PTXCONF_SYSROOT_TARGET)/usr/lib/libmongoose.so.$(MONGOOSE_VERSION)
	@ln -s $(PTXCONF_SYSROOT_TARGET)/usr/lib/libmongoose.so.$(MONGOOSE_VERSION) \
		$(PTXCONF_SYSROOT_TARGET)/usr/lib/libmongoose.so.5
	@ln -s $(PTXCONF_SYSROOT_TARGET)/usr/lib/libmongoose.so.5 \
		$(PTXCONF_SYSROOT_TARGET)/usr/lib/libmongoose.so
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

$(STATEDIR)/mongoose.targetinstall:
	@$(call targetinfo, $@)

	@$(call install_init, mongoose)
	@$(call install_fixup, mongoose,PACKAGE,mongoose)
	@$(call install_fixup, mongoose,PRIORITY,optional)
	@$(call install_fixup, mongoose,VERSION,$(MONGOOSE_VERSION))
	@$(call install_fixup, mongoose,SECTION,base)
	@$(call install_fixup, mongoose,AUTHOR,"code.google.com")
	@$(call install_fixup, mongoose,DEPENDS,)
	@$(call install_fixup, mongoose,DESCRIPTION,"Web server software")

	@$(call install_copy, mongoose, 0, 0, 0644, \
		$(MONGOOSE_DIR)/$(MONGOOSE)/_mongoose.so,  \
		/usr/lib/libmongoose.so.$(MONGOOSE_VERSION), y)

	@$(call install_link, mongoose, libmongoose.so.$(MONGOOSE_VERSION), /usr/lib/libmongoose.so.5)
	@$(call install_link, mongoose, libmongoose.so.$(MONGOOSE_VERSION), /usr/lib/libmongoose.so)


	@$(call install_finish, mongoose)

	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

mongoose_clean:
	rm -rf $(STATEDIR)/mongoose.*
	rm -rf $(PKGDIR)/mongoose_*
	rm -rf $(MONGOOSE_DIR)
	rm -rf $(PTXCONF_SYSROOT_TARGET)/usr/lib/libmongoose.*

# vim: syntax=make
